#!/usr/bin/perl
# index.cgi
# Display all RAID controllers, logical units and ports

require './raid-lib.pl';
use Data::Dumper;

use strict;
use warnings;

our ( %in, %text );


&ReadParse();

&header();

# Display controllers and basic status

# test everything's OK.
my $twcontrollers=&getcontinfo;

if ($twcontrollers eq '') {
	# tw_cli error
	print $text{'index_errtwcli'};
	&footer("/", $text{'index'});
	exit;
	}

if ( $twcontrollers =~ "No controller found" ) {
	# no controllers found
	print $text{'index_none'};
	&footer("/", $text{'index'});
	exit;
	}

########################
# functions

sub display_lun_head {
		print "<tr bgcolor=\"#cccccc\"><td>UNIT</td><td>type</td><td>Status</td><td>rebuild</td><td>Size</td><td>Blocks</td><td>&nbsp;</td></tr>" ;

}

sub display_lun_head_short {
		print "<tr bgcolor=\"#cccccc\"><td>UNIT</td><td>type</td><td>Status</td><td>rebuild</td><td>Size</td><td>&nbsp;</td></tr>" ;

}

sub display_lun {
	# displays a lun
	#
	#
	
	my $controller = shift;
	my $unit       = shift;
	my $uv         = shift ;
	
	my $color="#dd3311";
	if ($uv->{'Status'} =~ /OK/) {
		$color="#ffffff";
		}

	print "<tr>
	         <td> $unit </td>
			 <td>$uv->{'UnitType'}</td>
			 <td bgcolor=\"$color\">$uv->{'Status'}</td>
          	 <td>$uv->{'Cmpl'}</td>
			 <td>$uv->{'Size'}&nbsp;GB</td>
			 <td>$uv->{'Blocks'}</td>
			 <td><a href=\"?voldet=$unit&ctl=$controller\" title=\"$text{'ctlinfo'}\">$text{'view_header'}</a></td>
		  </tr>";
		  
}

sub display_lun_short {
	# displays a lun
	#
	#
	
	my $controller = shift ;
	my $unit       = shift ;
	my $uv         = shift ;
	
	my $color="#dd3311";
	if ($uv->{'Status'} =~ /OK/) {
		$color="#ffffff";
		}

	print "<tr>
	         <td> $unit </td>
			 <td>$uv->{'UnitType'}</td>
			 <td bgcolor=\"$color\">$uv->{'Status'}</td>
          	 <td>$uv->{'Cmpl'}</td>
			 <td>$uv->{'Size'}&nbsp;GB</td>
			 <td><a href=\"?voldet=$unit&ctl=$controller\" title=\"$text{'ctlinfo'}\">$text{'view_header'}</a></td>
		  </tr>";
		  
}


sub display_disks_head {
	print "<tr bgcolor=\"#cccccc\"><td>Port</td><td>Status</td><td>Unit</td><td>Size</td><td>Blocks</td><td>Model</td><td>Serial Number</td></tr>";
}

sub display_disks {

	my $port = shift;
	my $disk = shift;

	my $color="#dd3311";
	if ($disk->{'Status'} =~ /OK/) {
		$color="#ffffff";
		}

	print "<tr>
	         <td> $port </td>
			 <td>$disk->{'Status'}</td>
			 <td>$disk->{'Unit'}</td>
			 <td>$disk->{'Size'}</td>
			 <td>$disk->{'Blocks'}</td>
			 <td>$disk->{'Model'}&nbsp;</td>
			 <td>$disk->{'Serial'}</td>
		  </tr>";
	
}

########################
# controller details
if ($in{'ctldet'}) {
	
	# dbut du tableau HTML
	print "<table border=\"1\"><tr bgcolor=\"#9999ff\"><th colspan=\"8\">$text{'index_ctlinfo'}&nbsp;$in{'ctldet'}</th></tr>
	<tr bgcolor=\"#9999ff\"><th colspan=\"8\">$text{'index_return'}</th></tr>";

	display_lun_head();
	
	my $controller = $twcontrollers->{$in{'ctldet'}};
	
	foreach  my $uk ( keys %{$controller->{'Unit'}}) {
		my $uv = $controller->{'Unit'}->{$uk};
			display_lun($in{'ctldet'}, $uk, $uv);
		}	


	print "</tr>
	<tr bgcolor=\"#9999ff\"><th colspan=\"8\">
	$text{'index_ports'}</th></tr><tr><td>";
	
	display_disks_head();
	
	foreach my $port ( keys %{$controller->{Drive}} ) {
		display_disks( $port, $controller->{Drive}->{$port} )
	}
		
	# fin du tableau gnral
	print "</table>";
	&footer("/", $text{'index'});
	exit;
}

########################
# logical volume details
if ($in{'voldet'} && $in{'ctl'}) {
	
	print "<table border=\"1\"><tr bgcolor=\"#9999ff\"><th colspan=\"9\">$text{'index_return_info'}&nbsp;cont.&nbsp;$in{'ctl'}&nbsp;unit&nbsp;$in{'voldet'}</th></tr>";

	display_lun_head();
	
	my $controller = $twcontrollers->{$in{'ctl'}};
	
	display_lun($in{'ctl'}, $in{'voldet'}, $controller->{'Unit'}->{$in{'voldet'}} );
	
	print "</tr>
	<tr bgcolor=\"#9999ff\"><th colspan=\"8\">
	$text{'index_ports'}</th></tr><tr><td>";
	
	display_disks_head();
	
	for my $port (  @{$controller->{'Unit'}->{$in{'voldet'}}->{'Port'}} ) {
		display_disks( $port, $controller->{Drive}->{$port} )
	}	
	
	print "</table>";
	&footer("/", $text{'index'});
	exit;
	}

