#!/usr/bin/perl -w

do '../web-lib.pl';

use raid;
use diagnostics;

&init_config();

if ( $tconfig{'inframe'} ) {
    &header( "", "", undef, 0, 1, 0 );
} else {
    &PrintHeader();
    print << '	EOF';
	<!doctype html public "-//W3C//DTD HTML 4.0 Final//EN">
	<HTML>
	<HEAD>
	<LINK REL="stylesheet" TYPE="text/css" HREF="style.css">
	</HEAD>
	<BODY>
	EOF

}

# get raid controllers info
sub getcontinfo {

    #
    my ( $etat, $refinfo ) = raid::info();
    if ($etat) {

        # erreur
        print "Error ";
        $refinfo->{Erreur} ? print $refinfo->{Erreur} : print $refinfo;
        return;
    }

    return $refinfo;
}

sub unit_icon {

    # renvoie l'icne
    my ( $unittype, $status ) = @_;

    $status = 'OTHER' unless $status eq 'OK';

    my %translate = (
        JBOD => {
            OK    => 'images/raid_0_bg.png',
            OTHER => 'images/raid_0_fail_bg.png',
        },
        SPARE => {
            OK    => 'images/raid_spare_bg.png',
            OTHER => 'images/raid_spare__failed_bg.png',
        },
        SINGLE => {
            OK    => 'images/raid_single_bg.png',
            OTHER => 'images/raid_single_fail_bg.png',
        },
        'RAID-0' => {
            OK    => 'images/raid_0_bg.png',
            OTHER => 'images/raid_0_bg.png',
        },
        'RAID-1' => {
            OK    => 'images/raid_1_bg.png',
            OTHER => 'images/raid_1_fail_bg.png',
        },
        'RAID-5' => {
            OK    => 'images/raid_5_bg.png',
            OTHER => 'images/raid_5_fail_bg.png',
        },
        'RAID-6' => {
            OK    => 'images/raid_6_bg.png',
            OTHER => 'images/raid_6_fail_bg.png',
        },
        'RAID-10' => {
            OK    => 'images/raid_10_bg.png',
            OTHER => 'images/raid_10_fail_bg.png',
        },
        'RAID-01' => {
            OK    => 'images/raid_10_bg.png',
            OTHER => 'images/raid_10_fail_bg.png',
        },
        'RAID-50' => {
            OK    => 'images/raid_50_bg.png',
            OTHER => 'images/raid_50_fail_bg.png',
        },
        'RAID-05' => {
            OK    => 'images/raid_50_bg.png',
            OTHER => 'images/raid_50_fail_bg.png',
        },
        'RAID-60' => {
            OK    => 'images/raid_60_bg.png',
            OTHER => 'images/raid_60_fail_bg.png',
        },
        'RAID-05' => {
            OK    => 'images/raid_50_bg.png',
            OTHER => 'images/raid_50_fail_bg.png',
        },
    );

    return $translate{$unittype}{$status};
}

# Affiche le menu icones

sub print_ctl_infos {
    my $controllers = &getcontinfo;

    if ( $controllers =~ "No controller found" ) {

        # no controllers found
        print $text{'index_none'};
    } else {
        &all_infos($controllers);
    }
}

sub all_infos {
    my %treeicons = (
        vertical   => 'images/vertical.png',
        horizontal => 'images/horizontal.png',
        angle      => 'images/angle.png',
        treesplit  => 'images/treesplit.png',
        space      => 'images/tree_space.gif'
    );

    # DISPLAY  controllers and basic status

    my $twcontrollers = shift;
    ########################
    # affichage

    print "<br><br>";

    print
      "<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">
        <tr bgcolor=\"#9999ff\">
		 <th colspan=\"2\">$text{'index_ctl'}</th>
		 <th colspan=\"2\">$text{'index_vol'}</th>
		 <th colspan=\"2\">$text{'index_ports'}</th>
		 </tr>\n";

    foreach my $controller ( sort keys %$twcontrollers ) {

        my $controllerdata = $twcontrollers->{$controller};

        my $controllericon = "images/card.png";

        print "<tr>
	        <td width=\"64\" height=\"64\"><img src=\"$controllericon\"></td>
			<td width=\"192\"><a href=\"details.cgi?ctldet=$controller\" title=\"$text{'ctlinfo'}\"> $controller </a></td>
			<td colspan=\"4\">&nbsp;</td>
		   </tr>";

        my $unitcount = 1;
        my $unitlast  = keys %{ $controllerdata->{'Unit'} };

        foreach my $unit ( sort keys %{ $controllerdata->{'Unit'} } ) {
            my $unitdata     = $controllerdata->{'Unit'}->{$unit};
            my $treeicon     = $treeicons{treesplit};
            my $verticalicon = $treeicons{vertical};
            my $portsingle   = $treeicons{space};

            if ( $unit eq "-" ) {
                my $uniticon =
                  unit_icon( $unitdata->{'UnitType'}, $unitdata->{'Status'} );

                $verticalicon = $treeicons{treesplit};
                $portsingle   = $treeicons{horizontal};

                if ( ++$unitcount > $unitlast ) {
                    $treeicon     = $treeicons{angle};
                    $verticalicon = $treeicons{space};
                }

# 		print "<tr>
# 		        <td><img src=\"$treeicon\"  width=\"64\" height=\"64\"></td>
# 				<td  width=\"192\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"></td>
# 				<td  width=\"64\" height=\"64\"><img src=\"$uniticon\"></td>
# 		        <td><a href=\"details.cgi?voldet=$unit&ctl=$controller\" title=\"$text{'ctlinfo'}\">$unit ($unitdata->{'Size'} GB) </a></td>
# 				<td colspan=\"2\">&nbsp;</td>
# 			   </tr>";

            } else {
                my $uniticon =
                  unit_icon( $unitdata->{'UnitType'}, $unitdata->{'Status'} );

                if ( ++$unitcount > $unitlast ) {
                    $treeicon     = $treeicons{angle};
                    $verticalicon = $treeicons{space};
                }

                print "<tr>
		        <td><img src=\"$treeicon\"  width=\"64\" height=\"64\"></td>
				<td  width=\"192\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"></td>
				<td  width=\"64\" height=\"64\"><img src=\"$uniticon\"></td>
		        <td><a href=\"details.cgi?voldet=$unit&ctl=$controller\" title=\"$text{'ctlinfo'}\">$unit ($unitdata->{'Size'} GB) </a></td>
				<td colspan=\"2\">&nbsp;</td>
			   </tr>";

            }
            my $portcount = 1;
            my $portlast  = @{ $unitdata->{'Port'} };

            foreach my $port ( sort @{ $unitdata->{'Port'} } ) {
                my $porticon = "images/hdd.png";
                $porticon = "images/hdd_bad.png"
                  unless $controllerdata->{'Drive'}{$port}{'Status'} eq 'OK';

                my $porttreeicon = $treeicons{treesplit};
                if ( ++$portcount > $portlast ) {
                    $porttreeicon = $treeicons{angle};
                }
                if ( $unit eq "-" ) {
                    $porttreeicon = $treeicons{horizontal};
                }

                print "<tr>
			        <td><img src=\"$verticalicon\" width=\"64\" height=\"64\"></td>
					<td  width=\"192\" height=\"64\"><img src=\"$portsingle\" width=\"64\" height=\"64\"><img src=\"$portsingle\" width=\"64\" height=\"64\"><img src=\"$portsingle\" width=\"64\" height=\"64\"></td>
			        <td><img src=\"$porttreeicon\" width=\"64\" height=\"64\"></td>
					<td  width=\"192\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"><img src=\"$treeicons{horizontal}\"  width=\"64\" height=\"64\"></td>
			        <td width=\"64\" height=\"64\"><img src=\"$porticon\"></td>
					<td><a href=\"details.cgi?voldet=$unit&ctl=$controller\" title=\"$text{'ctlinfo'}\">$port ($controllerdata->{'Drive'}{$port}{'Size'} GB)</a></td>
				   </tr>";
            }
        }
    }

    print "</table>";

}

&print_ctl_infos();

#1;

